include "strtools.sol"
include "path.sol"

` PY to .SOL
` this program deindent a python source
` by adding enders of control structures, in the Scriptol's style
` www.scriptol.com
` Licence of PYto.SOL : Public Domain

/*
  Some first translations you need to perform:
  - add type or dyn to each variable
  - replace def by type or void
  - replace following symbols:
  len       strlen
  import    include ""
  #         `
  """       Scriptol's multiline comment (can't write it)
  ==        =
  :         --       (in subsripting)
  :         ?        (in one-line control structures)
  range()   x..y
  open      fopen
  os.path.  Dir.
  sys.exit  exit
*/

array constructs = ( "while", "for", "if", "def", "class", "elif", "else" )
array keyspace = ( "while", "for", "def", "class" , "try" )
array lastkey = ()
array listindent = ()
array words = ()
file f
int indent = 0
text  word
int level = 0

int whichindent(text line) :
  int i = 0
  while line[i] = " " ? i + 1
return i


` for each deindenting level, process end of control structure
` until end of deindenting

void deindent()

 while forever:
   if level < 1 ? break           ` should not occur
   int li = listindent[level]
   if li <= indent ? break
   level - 1
   if word in ( "else", "elif") ? continue       ` else doesn't deindent

   ` processing end of control structure

   text key = lastkey[level]
   if key in constructs:
     li = listindent[level]
     text eline
     eline.fill(" ", li)
     f.write(eline + "/" + key + "\n")
   /if
 /while
return

void enders()

 while forever:
   if level < 1 ? break           ` should not occur
   int li = listindent[level]
   level - 1

   text key = lastkey[level]
   if key in constructs:
     li = listindent[level]
     text eline
     eline.fill(" ", li)
     f.write(eline + "/" + key + "\n")
   /if
 /while
return


void main(array param):

  int l = param.size()
  if l not in 2..3
    print "usage: sol pyto nomfic.py"
    exit()
  /if

  text fname = param[1]
  text temp
  text solname = ""
  print "Processing", fname

  array lines
  lines.load(fname)

  text node, ext
  node, ext = Path.splitExt(fname)
  solname = node + ".sol"


  f.open(solname, 'w')

  text current = ""
  int lastindent = 0
  boolean skip = false

  level = 0
  int linenum = 0

  for text line in lines:
    linenum + 1           ` set line number from 1 to size of lines
    ` if inside comment
    if skip:
      temp = line.trim()
      if strlen(temp) > 2
        if temp[--3] = '"""'
          skip = false
          //line = temp[--3] + "*/\n"
        /if
      /if
      f.write(line)
      continue
    /if

    line = line.rtrim()           ` remove trailing codes
    line = current + line         ` merge line to previous

    ` processing blank line

    l = strlen(line)
    if l = 0
      current = ""
      f.write(line + "\n")
      continue
    /if
    indent = whichindent(line)
    if indent = l:           ` blank line
      current = ""
      f.write(line + "\n")
      continue
    /if

    ` processing splitted line

    if line[-1..] = '\\'
      current = line[..-2]
      continue
    /if

    ` processing comments

    temp = line.ltrim()
    if temp[0] = "#"
      current = ""
      //temp = "\`" +line[1..]
      f.write(temp + "\n")
      continue
    /if

    if temp = '"""'
      skip = true
      //f.write("/*\n")
      f.write(temp + "\n")
      continue
    /if

    ` processing indenting

    words = line.split(" \t\n\r():;[]{}")
    word = words[0]

    ` if more indented, put depth in stack

    if indent > lastindent:
      level + 1
      listindent[level] = indent
    else:
      boolean deindent = false
      if indent
      < lastindent : deindent = true
      > 0:           if linenum = lines.size() ? deindent = true
      /if
      if deindent ? deindent()
    /if

    if word in constructs
      if word in ("else", "elif") ? word = "if"
      lastkey[level] = word
    /if

    lastindent = indent
    current = ""
    if word in keyspace ? f.write("\n")
    f.write(line + "\n")
  /for

  ` end of file, flushing remaining enders
  if level > 0 ? enders()

  f.close()
  print solname, "created"
return


main($argv)
